Foreman - Bug #11791

N+1 query on hosts#index retrieving puppet_proxy
09/14/2015 03:45 AM - Dominic Cleal

Status: Closed
Priority: Low
Assignee: Marek Hulén
Category: Performance
Target version: 1.10.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2712
Description

Since #11704, the hosts#index page is generating an N+1 query warning on the host puppet_proxy attribute.

http://0.0.0.0:3000/hosts

N+1 Query detected

Host::Managed => [:puppet_proxy]

Add to your finder: :includes => [:puppet_proxy]

N+1 Query method call stack
/home/dcleal/code/foreman/foreman/app/models/host_status/configuration_status.rb:37:in “to_gl

\

\

\

\

\

\
obal'

\ /home/dcleal/code/foreman/foreman/app/models/host_status/global.rb:10:1in “block in build'

| /home/dcleal/code/foreman/foreman/app/models/host_status/global.rb:10:in "map’'

\ /home/dcleal/code/foreman/foreman/app/models/host_status/global.rb:10:in “build’'

| /home/dcleal/code/foreman/foreman/app/models/host/managed.rb:889:in “build_global_status'

| /home/dcleal/code/foreman/foreman/app/helpers/hosts_helper.rb:94:in “host_global_status_icon_
class_for_host'

| /home/dcleal/code/foreman/foreman/app/helpers/hosts_helper.rb:83:in “name_column'

| /home/dcleal/code/foreman/foreman/app/views/hosts/_list.html.erb:22:in “block in _app_views_h
osts__list_html_erb_ 275981041170289430_92907540"

| /home/dcleal/code/foreman/foreman/app/views/hosts/_list.html.erb:17:in ~_app_views_hosts__1lis
t_html_erb_ 275981041170289430_92907540"'

| /home/dcleal/code/foreman/foreman/app/views/hosts/index.html.erb:4:in ' _app_views_hosts_index
_html_erb_ 1661929246903238241_92718560"

It probably doesn't even need to check for puppet_proxy itself, but just checking the presence of an ID may be enough.

Related issues:
Related to Foreman - Bug #11704: Configuration no report appears as "green" icon Closed 09/06/2015

Associated revisions

Revision 7397bf15 - 09/15/2015 10:08 AM - Marek Hulan

Fixes #11791 - avoid N+1 query caused by configuration status

Revision 2a624d77 - 09/17/2015 10:59 AM - Dominic Cleal
refs #11833, #11791 - fix N+1 query during config status applicability check

Reapplies the fix from 7397bf1 which was lost in €543c57.

History

#1 - 09/14/2015 03:46 AM - Dominic Cleal

- Related to Bug #11704: Configuration no report appears as "green" icon added

#2 - 09/14/2015 04:25 AM - Marek Hulan

- Status changed from New to Assigned
https://projects.theforeman.org/issues/11704

- Assignee set to Marek Hulan

#3 - 09/14/2015 04:28 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2712 added
- Pull request deleted ()

#4 - 09/15/2015 11:02 AM - Marek Hulan
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 7397bf15ef66bfb26bedc3c2bf8e63ef5a63e071.
